// Copyright 1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "TransactionController.h"
#import <CyberCash/CCTransaction.h>
#import <CyberCash/CCConnection.h>
#import <OmniBase/rcsid.h>
#import <OmniFoundation/OFOid.h>

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Applications/OmniCreditAuthorizer/TransactionController.m,v 1.3 1999/11/12 23:41:53 luke Exp $")

@implementation TransactionController

- init;
{
    [super init];
    [NSBundle loadNibNamed:@"Transaction" owner:self];
    [[orderNumberField window] makeKeyAndOrderFront:self];
    [orderNumberField setStringValue:[[OFOid oid] sqlString]];
    return self;
}

- (void)authorize:sender;
{
    CCTransaction *transaction, *response;
    CCConnection *connection;
    NSString *status, *string;

    transaction = [[CCTransaction alloc] init];
    [transaction setOrderID:[orderNumberField stringValue]];
    [transaction setCardNumber:[cardNumberFormCell stringValue]];
    [transaction setExpiration:[expirationFormCell stringValue]];
    [transaction setAmount:[amountFormCell stringValue]];
    [transaction setName:[nameFormCell stringValue]];
    [transaction setAddress:[addressFormCell stringValue]];
    [transaction setCity:[cityFormCell stringValue]];
    [transaction setState:[stateFormCell stringValue]];
    [transaction setZipcode:[zipFormCell stringValue]];

    connection = [CCConnection sharedConnection];
    response = [connection captureCreditCardTransaction:transaction];

    status = [response messageStatus];
    if ([status isEqualToString:@"success"]) {
        [authorizeButton setEnabled:NO];
        [requiredForm setEnabled:NO];
        [optionalForm setEnabled:NO];
    }
    [statusField setStringValue:status];
    if (!(string = [response merchantTransactionID]))
        string = @"?";
    [merchantIDField setStringValue:string];
    if (!(string = [response message]))
        string = @"?";
    [messageField setStringValue:string];
}

@end
